/*
 *
 * Copyright (c) 2006-2019, Speedment, Inc. All Rights Reserved.
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); You may not
 * use this file except in compliance with the License. You may obtain a copy of
 * the License at:
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS, WITHOUT
 * WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the
 * License for the specific language governing permissions and limitations under
 * the License.
 */

package com.speedment.runtime.compute.expression.orelse;

import static com.speedment.runtime.compute.expression.NonNullableExpression.NullStrategy.USE_DEFAULT_VALUE;
import static org.junit.jupiter.api.Assertions.assertEquals;

import com.speedment.runtime.compute.ToBigDecimalNullable;
import org.junit.jupiter.api.Test;

import java.math.BigDecimal;

final class ToBigDecimalOrElseTest {

    @Test
    void nullStrategy() {
        assertEquals(USE_DEFAULT_VALUE, new DummyToBigDecimalOrElse().nullStrategy());
    }

    private static final class DummyToBigDecimalOrElse implements ToBigDecimalOrElse<Integer> {

        @Override
        public BigDecimal defaultValue() {
            return null;
        }

        @Override
        public BigDecimal apply(Integer object) {
            return null;
        }

        @Override
        public ToBigDecimalNullable<Integer> innerNullable() {
            return null;
        }
    }
}
